package	jp.co.sds_corp.util.jmx.rmi.server;

import java.net.InetAddress;

import javax.management.MBeanServer;
import javax.management.ObjectName;
import javax.naming.InitialContext;

import jp.co.sds_corp.util.common.CmnLog;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.jmx.AbstractMBeanService;

public class RMIConnectorService extends AbstractMBeanService
   implements RMIConnectorServiceMBean
{
	public static String JNDI_NAME = "jp.co.sds_corp.util.jmx:rmi";
	public static String JMX_NAME = "jp.co.sds_corp.util.jmx";
	public static String PROTOCOL_NAME = "rmi";

	private MBeanServer server;
	private RMIConnectorImpl adaptor;
	private String mHost;
	private String mName;

	public RMIConnectorService() {
		mName = null;
	}

	public RMIConnectorService( String name ) {
		mName = name;
	}

	public ObjectName getObjectName( MBeanServer server, ObjectName name )
		throws javax.management.MalformedObjectNameException
	{
		this.server = server;
		return new ObjectName( OBJECT_NAME );
	}

	public String getName() {
		return "JMX RMI Connector";
	}

	public String getJNDIName() {
		if (mName != null) {
			return JMX_NAME + ":" + mHost + ":" + PROTOCOL_NAME + ":" + mName;
		} else {
			return JMX_NAME + ":" + mHost + ":" + PROTOCOL_NAME;
		}
	}

	public void initService( IConfiguration config ) throws Exception {
		mHost = InetAddress.getLocalHost().getHostName();
		adaptor = new RMIConnectorImpl( server );
	}

	public void startService() throws Exception {
		new InitialContext().bind( getJNDIName(), adaptor );
	}

	public void stopService() {
		try {
			new InitialContext().unbind( getJNDIName() );
		} catch( Exception ex ) {
			CmnLog.error( this, "unbind failure", ex );
		}
	}
}
